Option Strict Off
Option Explicit On
Imports System.Windows.Forms
'------------------------------------ 2023/11/09 ------------------------------------
Public Class 四frmDlgPctFilesList

#Region "宣言"
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private mDlgUserID As Integer = 0  'gmDlgFileゲーム用  /  gmDlgFileスイスイ用
    Private mDlgUser指定背景色 As Integer = -1
    Private mFirstShow As Boolean = True
    Private mDoEventsCall As Boolean = False : Private mDoLoopCount As Integer = 0
    Private mMenuHight As Integer
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private Const cDlgWnd画像ファイル名 As String = "●DlgList.bmp"
    Private Const cBmpMinWD As Integer = 1000, cBmpMaxWD As Integer = 3000
    Private Const cBmpMinHT As Integer = 1000, cBmpMaxHT As Integer = 2000
    Private Const c画像庫最大画数 As Integer = 16 * 12
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private WithEvents mDlgSetSize As 四frmDlgPctFilesListCHG
    Private ooFileListDrag操作 As New 五clsPctFilesListDRAG
    Public mImg現在のファイル As Image   '2022/0717
    Private ooWNDバー As 四frmDlgFileOpeningMsg = Nothing
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private Const cToplblFile As Integer = 12          ' lblFile.Top = mMenuHight ( Me.MainMenu1.Height ) + cToplblFile 
    Private Const cLeft As Integer = 15
    Private Const cTop As Integer = 45
    Private Const cRight As Integer = 15
    Private Const cBottom As Integer = 15
    Private Const cListSpaceXY As Integer = 10
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private mListItemWDHT As Integer = 100
    Private mListColX As Integer = 7
    Private mListLowY As Integer = 5
    Private mListMax As Integer = mListColX * mListLowY
    Private mListPichXY As Integer = 110
    Private mFileRects(0) As RECT
    Private mBmpMaxWD As Integer = 2000
    Private mBmpMaxHT As Integer = 1500
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private m使用中リストIDX As Integer = 0
    Private mファイル群の名前配列(200) As String
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private mCurList As Integer = 0
    Private OLEDropFilesTopindex As Integer
    Private mOnAfterSizeDlg As Boolean = False
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private mCurBoxWaku As New 五clsWakuwaku
    Private mCurClickWaku As New 五clsWakuwaku
    '--------------------------------------------------------------------------------------------------------------------------------------
    Private mBmp変更済み As Boolean = False
    Private m画像リストBmpFullPath As String = ""
    Private m画像ファイルフォルダ履歴 As String '最初に表示するフォルダ名---指定しなければ CurDir$ を表示     
    Private pctCurBmp縦横比率 As Single = 1.0
    '**************************************************************************************************************************************
    Event 画像ファイルの選択が実行された(ByVal rNewファイル As String, ByRef wChangeDone As Boolean)
    Event 画像ファイルの切替タイマー(ByVal rCurファイル As String, ByVal rNextファイル As String, ByRef wChangeDone As Boolean)
    Event 画像ファイルの切替タイマー一秒ごとの通知(ByRef wIs満期 As Boolean)
    '**************************************************************************************************************************************
    Private WithEvents イベントgAppEventMaker As 五clsEventMaker
    '**************************************************************************************************************************************
#End Region

#Region "AppIniFileOp"
    Private Function zzAppIniFileOp(ByVal Load_0_QueryUnload_1_Resize_2_DoIniSave_3 As Long) As Boolean
        '読出し時に　INI ファイルが存在しない場合は　False　を返します。
        If gggAppIniFile Is Nothing Then Return False
        Return gggAppIniFile.aaAppIniFileOp_フォームサイズと位置だけ_共通処理(Load_0_QueryUnload_1_Resize_2_DoIniSave_3, Me, "-" & Me.Text)
    End Function
#End Region

#Region "フォームイベント"

    Private Sub 四frmDlgPctFilesList_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged
        '--------------------------------------------------
        gggbol = イベントgAppEventMaker.MakeEventフォームの表示消去(mDlgUserID, (Me.Visible))
        '--------------------------------------------------
    End Sub

    Friend Function aa初期設定オブジェ設定(ByVal rDlgCap As String, ByVal rDlgUserID As Integer, ByVal r背景色 As Integer, ByVal r使用するmn8スイスイ用カード型を設定 As Boolean) As Boolean
        Me.Text = rDlgCap
        m画像リストBmpFullPath = GMCOMアプリフォルダ("\") & rDlgCap & cDlgWnd画像ファイル名
        mDlgUserID = rDlgUserID  'gmDlgFileゲーム用  /  gmDlgFileスイスイ用
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                mn8suiyula.Visible = False
                mn8スイスイ用カード型を設定.Visible = False
                mn000ファイルメニュー.Text = "ゲーム用ファイル (&F)"
                mn00選択画像で実行.Text = "選択画像でゲームを開始 (&P)"
            Case gmDlgFileスイスイ用
                mn8suiyula.Visible = True
                mn8スイスイ用カード型を設定.Visible = (r使用するmn8スイスイ用カード型を設定 And True)
                mn000ファイルメニュー.Text = "スイスイ用ファイル (&F)"
                mn00選択画像で実行.Text = "選択画像をカレントに設定 (&P)"
        End Select
        mn00pop選択画像で実行.Text = mn00選択画像で実行.Text
        '-----------------------------------------------
        '2022/06/24  それぞのユーザーが、任意の背景色を選択できるようにする。
        mDlgUser指定背景色 = r背景色 'mDlgUserID それぞれに背景色を指定できる。
        '-----------------------------------------------
        mMenuHight = Me.MainMenu1.Height
        '-----------------------------------------------
        With lbl削除モード
            .SetBounds(0, 0, .Width, .Height)
            .Visible = False
        End With
        '-----------------------------------------------
        pファイル選択でダイアログ閉じる = True '2023/03/18 add new
        '-----------------------------------------------
        Return True
    End Function
    '***********************************************************************
    Friend Function aaウインドウ初期化作成() As String
        '---------------------------------------------------------------------------
        イベントgAppEventMaker = gAppEventMaker
        '---------------------------------------------------------------------------
        mImg現在のファイル = pctAppDef.Image.Clone
        '---------------------------------------------------------------------------
        Me.Icon = frmMain.Icon : Me.Visible = False
        mBmp変更済み = False : pctCurBmp縦横比率 = 1 : mCurList = 0
        '---------------------------------------------------------------------------
        If m画像ファイルフォルダ履歴 = "" Then m画像ファイルフォルダ履歴 = GMCOMアプリフォルダ("")
        '---------------------------------------------------------------------------
        '2022/05/22 *************** ここですでに *************** ファイルは読み込み済み。
        '---------------------------------------------------------------------------
        Dim rBmpMaxWD As Integer = mBmpMaxWD
        Dim rBmpMaxHT As Integer = mBmpMaxHT
        Dim rListItemWDHT As Integer = mListItemWDHT
        Dim rListColX As Integer = mListColX
        Dim rListLowY As Integer = mListLowY
        gggbol = zzサイズ設定とフォームリサイズ(True, True, False, rBmpMaxWD, rBmpMaxHT, rListItemWDHT, rListColX, rListLowY)
        '---------------------------------------------------------------------------
        Dim 履歴ファイルは存在 As Boolean = False
        '---------------------------------------------------------------------------
        If Ⅹファイルは存在(m画像リストBmpFullPath) Then
            Try
                Dim img As Image = System.Drawing.Image.FromFile(m画像リストBmpFullPath)
                If img IsNot Nothing Then
                    If ⅩImage_新規作成_再作成(pctFileList.Image, img.Width, img.Height) Then
                        gggbol = ⅩImage全域StrechCopy(pctFileList.Image, img)
                        img.Dispose()
                        履歴ファイルは存在 = True
                    End If
                End If
            Catch
                MsgBox("ERROR in aaウインドウ初期化作成()" + vbCrLf + ErrorToString())
                Return False
            End Try
        End If
        '---------------------------------------------------------------------------
        Dim NewFile As String = zz画像ファイル名取得_エラーなら_規定の内蔵画像に設定__m使用中リストIDX_と_mCurList_を設定("")
        '---------------------------------------------------------------------------
        If "" <> aa画像ファイルオープン_into_ImageBox(NewFile, mImg現在のファイル, pctCurBmp縦横比率) Then
            Call zzリストの一セルに描画(pctFileList, "@usecur@", m使用中リストIDX, mFileRects, mListItemWDHT, True)
            If Not 履歴ファイルは存在 Then mBmp変更済み = True
        End If
        With mCurBoxWaku
            gggbol = .aa_Make(Me, 3, Color.Red)
            gggbol = .aa_BringToFront()
            .LineWidth = 5
            .CurColor = Color.Red
            .Visible = True
        End With
        With mCurClickWaku
            gggbol = .aa_Make(Me, 2, Color.Blue)
            gggbol = .aa_BringToFront()
            .LineWidth = 3
            .CurColor = Color.Blue
            .Visible = True
        End With
        lblFile.BringToFront()
        '---------------------------------------------------------------------------
        If Not zzAppIniFileOp(0) Then gggint = ⅩFormMove(gcoフォームをスクリーン中心に移動, Me)
        '---------------------------------------------------------------------------
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                gggbol = イベントgAppEventMaker.MakeEventタイマーのオンオフonスイスイonff(gmDlgFileゲーム用, False)
            Case gmDlgFileスイスイ用
                gggbol = イベントgAppEventMaker.MakeEventタイマーのオンオフonスイスイonff(gmDlgFileスイスイ用, False)
        End Select
        '---------------------------------------------------------------------------
        'qqqqq "mBmp変更済み = " + CStr(mBmp変更済み)
        'qqqqq "pctCurBmp WD/HT = " + CStr(pctCurBmp.Width) + "   " + CStr(pctCurBmp.Height)
        'For a = 1 To UBound(mファイル群の名前配列) : qqqqq(Format(a, "000") + "=" + mファイル群の名前配列(a)) : Next
        Return NewFile
    End Function
    '***********************************************************************
    Friend Function aaファイル画像DlgShow(ByVal rOwner As Form) As Boolean
        Try
            If Me.Visible Then Return True
            Me.Owner = rOwner
            Me.Visible = True
            '-----------------------------------------------
            If Not zzAppIniFileOp(0) Then gggint = ⅩFormMove(gcoフォームをスクリーン中心に移動, Me)
            gggint = zzAppIniFileOp(2)  '必ず呼び出します。
            '-----------------------------------------------
            If mFirstShow Then
                mFirstShow = False
                gggstr = aa画像ファイル新規設定後のリスト選択表示処理(p画像ファイル現在使用)
            End If
            '-----------------------------------------------
            lbl削除モード.BringToFront()
            '-----------------------------------------------
            Return True
        Catch
            MsgBox(ErrorToString)
            Return False
        End Try
    End Function

    Private Sub 四frmDlgPctFilesList_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
        qqqqq("四frmDlgPctFilesList_Disposed")
    End Sub
    '***********************************************************************
    Private Sub 四frmDlgPctFilesIOList_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        pctFileList.SetBounds(0, mMenuHight, 0, 0, BoundsSpecified.Location)
        mCurBoxWaku.Visible = True : mCurBoxWaku.aa_BringToFront()
        mCurClickWaku.Visible = True : mCurClickWaku.aa_BringToFront()
        pctDrag.Visible = False
        pctFileList.AllowDrop = True
        gggbol = ⅩFormSizeSetByControlSize(Me, pctFileList, 0, 0, True, False)
    End Sub
    '***********************************************************************
    Private Sub 四frmDlgPctFilesIOList_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim Cancel As Boolean = e.Cancel
        Dim UnloadMode As CloseReason = e.CloseReason

        If lbl削除モード.Visible Then
            Call lbl削除モード_Click(Nothing, Nothing)
        End If

        If (gmアプリ終了する = False) And (UnloadMode = CloseReason.UserClosing Or UnloadMode = CloseReason.None) Then  '定数 vbFormCode  はアップグレードされませんでした。 
            Call mn900閉じる_Click(Nothing, Nothing)
            Cancel = -1
        Else
            'アプリ終わりの時のみ
            If mBmp変更済み Then
                Try
                    With pctFileList
                        .Refresh()
                        pctFileList.Image.Save(m画像リストBmpFullPath)
                        '    qqqqq(CStr(.Image.Width) + ", " + CStr(.Image.Height))
                    End With
                Catch ex As Exception
                    MsgBox("四frmDlgPctFilesList_FormClosing()" & vbCrLf & ex.Message)
                End Try
                mBmp変更済み = False
            End If
            If Me.Visible Then
                gggint = zzAppIniFileOp(2)
            End If
            gggint = zzAppIniFileOp(1)
            If mImg現在のファイル IsNot Nothing Then mImg現在のファイル.Dispose()
            '---------------------------------------------------------------
            gggbol = mCurBoxWaku.aa_Delete()      'Private mCurBoxWaku As New 五clsWakuwaku
            gggbol = mCurClickWaku.aa_Delete()    'Private mCurClickWaku As New 五clsWakuwaku
            '---------------------------------------------------------------
        End If
        'qqqqq "UnloadMode=" + CStr(UnloadMode)
        e.Cancel = Cancel
    End Sub
#End Region

#Region "メニューイベント"
    '***********************************************************************
    Private Sub mn900閉じる_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn900閉じる.Click
        gggint = zzAppIniFileOp(2)  '必ず呼び出します。
        gggint = zzAppIniFileOp(1)
        Me.Visible = False
        lbl削除モード.Visible = False
    End Sub
    '***********************************************************************
    Private Sub mn000ファイルメニュー_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn000ファイルメニュー.Click
        Call mn000画像用ファイル_Click_COM(mn00複数ファイルを登録, mn00選択画像で実行, mn00選択画像を外す)
        mn00画像リスト削除モードにする.Enabled = ppスイスイフラフラ_いずれも停止している And (lbl削除モード.Visible = False) And (zz現在の登録枚数() > 1)
    End Sub
    Private Sub mn000画像用ファイル_Click_COM(ByRef wmnu複数ファイルを登録 As ToolStripMenuItem, ByRef wmnu00選択画像で実行 As ToolStripMenuItem, ByRef wmnu選択画像を外す As ToolStripMenuItem)
        Select Case mDlgUserID
            '-------------------------------------------
            Case gmDlgFileゲーム用
                wmnu複数ファイルを登録.Enabled = (zz現在の登録枚数() < mListMax)
                Dim en As Boolean
                en = (mCurList <> m使用中リストIDX And (mCurList > 0))
                wmnu00選択画像で実行.Enabled = en
                wmnu選択画像を外す.Enabled = en And (mファイル群の名前配列(mCurList) <> p画像ファイル規定の内蔵画像)
                '-------------------------------------------
            Case gmDlgFileスイスイ用
                wmnu複数ファイルを登録.Enabled = (zz現在の登録枚数() < mListMax) And ppスイスイフラフラ_いずれも停止している
                Dim en As Boolean
                en = (mCurList <> m使用中リストIDX And (mCurList > 0))
                wmnu00選択画像で実行.Enabled = en
                wmnu選択画像を外す.Enabled = en And (mファイル群の名前配列(mCurList) <> p画像ファイル規定の内蔵画像) And ppスイスイフラフラ_いずれも停止している
                '-------------------------------------------
        End Select
    End Sub
    '***********************************************************************
    Private Sub mn00複数ファイルを登録_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00複数ファイルを登録.Click
        Try
            '複数のファイルを開く
            Dim FD As New 五clsFileDlgPathMenu : Dim wPath As String = "" : Dim wFullNames() As String = {""}
            If FD.ファイルダイアログ表示してファイルを選択(2, "複数の画像ファイルを登録　　■■　選択ファイル群の数は、空きリストの数以下にしてください。■■", FD.sフィルタ画像, m画像ファイルフォルダ履歴, wPath, wFullNames) Then
                '0ベースの配列を 1からの配列に変換
                Dim max As Integer = Ⅹ文配列をゼロベースから壱ベースにする(wFullNames)
                '-----------------------------------------------------------------------
                Dim addnum As Integer = zz複数ファイル画像をリストに追加(wFullNames, -1, -1)
            End If
        Catch
            MsgBox(ErrorToString())
        End Try
    End Sub
    '***********************************************************************
    Private Sub mn00選択画像で実行_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00選択画像で実行.Click
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                '-------------------------------------------
                'mダイアログで選択し画像に使用するファイル = mリスト内の選択ファイル
                If pファイル選択でダイアログ閉じる Then Call mn900閉じる_Click(mn900閉じる, New System.EventArgs())
                Dim wChangeDone As Boolean = False
                Dim idx As Integer = mCurList
                Dim newfile As String = mファイル群の名前配列(idx)
                RaiseEvent 画像ファイルの選択が実行された(newfile, wChangeDone)
                If wChangeDone Then
                    m使用中リストIDX = zz選択ファイル名からインデックス(newfile)
                    gggint = ooFileListDrag操作.aaCurUseIDX_セル枠設定(pctFileList, mFileRects(m使用中リストIDX), mCurBoxWaku)
                End If
                '-------------------------------------------
            Case gmDlgFileスイスイ用
                'mダイアログで選択しスイスイに使用するファイル = mリスト内の選択ファイル
                Dim wChangeDone As Boolean = False
                Dim idx As Integer = mCurList
                Dim newfile As String = mファイル群の名前配列(idx)
                RaiseEvent 画像ファイルの選択が実行された(newfile, wChangeDone)
                If wChangeDone Then
                    m使用中リストIDX = zz選択ファイル名からインデックス(newfile)
                    gggint = ooFileListDrag操作.aaCurUseIDX_セル枠設定(pctFileList, mFileRects(m使用中リストIDX), mCurBoxWaku)
                End If
                '-------------------------------------------
        End Select
    End Sub
    '***********************************************************************
    Private Sub mn00選択画像を外す_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00選択画像を外す.Click
        Call zzリストの選択画像を外す()
    End Sub
    '***********************************************************************
    Private Sub mn00画像リストファイルの再設定_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00画像リストファイルの再設定.Click
        If False = zz存在しないファイルが_mファイル群の名前配列内にあれば_TRUE_を返す() Then
            Call ⅩMsgBox_OK_情報("画像リストのファイル群は、すべて存在しています。" & gggCR2 & "画像リストの再設定は不要です。")
            Exit Sub
        End If
        '-----------------------------------------------------------------
        Dim a As Integer : Dim fff As String : Dim 削除あり As Boolean
        '-----------------------------------------------------------------
        Dim curidx As Integer = m使用中リストIDX
        Dim curfff As String = mファイル群の名前配列(m使用中リストIDX)
        '-----------------------------------------------------------------
        削除あり = zz存在しないファイルを_mファイル群の名前配列から削除(False)
        '-----------------------------------------------------------------
        If 削除あり Then
            gggbol = zzWNDバー_四frmDlgFileOpeningMsg_Op(1)
            For a = 1 To mListMax
                fff = mファイル群の名前配列(a)
                Call zzリストの一セルに描画(pctFileList, fff, a, mFileRects, mListItemWDHT, False)
                gggbol = zzWNDバー_四frmDlgFileOpeningMsg_Op(2)
            Next
            mBmp変更済み = mBmp変更済み Or True
            '-----------------------------------------------------------------
            '2022/06/19
            curidx = Ⅹ文を配列から探す(mファイル群の名前配列, curfff)
            If curidx > 0 Then
                m使用中リストIDX = curidx
            Else
                m使用中リストIDX = 1
            End If
            mCurList = m使用中リストIDX
            '-----------------------------------------------------------------
            '2019/10/21 add
            Dim s As String = aa画像ファイル新規設定後のリスト選択表示処理(mファイル群の名前配列(m使用中リストIDX))
            '-----------------------------------------------------------------
            gggbol = zzWNDバー_四frmDlgFileOpeningMsg_Op(3)
            pctFileList.Refresh()
        End If
    End Sub
    '***********************************************************************
    Private Sub mn00画像リストのデザイン変更_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00画像リストのデザイン変更.Click
        '************************************************************************************************************
        Dim OK As Boolean = False
        mDlgSetSize = New 四frmDlgPctFilesListCHG
        OK = mDlgSetSize.aa_DlgShow(Me.Text)
        mDlgSetSize.Dispose()
        If (Not OK) Then Exit Sub
        '************************************************************************************************************
        Dim OldCur As Integer = mCurList
        Me.Cursor = Cursors.WaitCursor
        '-----------------------------------------------------------------
        Call zz存在しないファイルを_mファイル群の名前配列から削除(True)
        '-----------------------------------------------------------------
        mCurBoxWaku.Visible = False
        mCurClickWaku.Visible = False
        pctFileList.Visible = False
        lblFile.Visible = False
        '-----------------------------------------------------------------
        mOnAfterSizeDlg = True
        gggbol = zzサイズ設定とフォームリサイズ(False, False, True)
        mOnAfterSizeDlg = False
        '-----------------------------------------------------------------
        gggbol = ⅩFormSizeSetByControlSize(Me, pctFileList, 0, 0, True, False)
        pctFileList.Visible = True
        lblFile.Visible = True
        '-----------------------------------------------------------------
        gggbol = zzWNDバー_四frmDlgFileOpeningMsg_Op(1)
        '-----------------------------------------------------------------
        Dim m, a, arymax As Integer : Dim f As String
        pctFileList.BackColor = ⅩColor構造体_from_色値(pリストの配色背景)
        m = Math.Min(UBound(mFileRects), mListMax)
        arymax = UBound(mファイル群の名前配列)
        For a = 1 To m
            If a > arymax Then f = "" Else f = mファイル群の名前配列(a)
            If f <> "" Then
                Call zzリストの一セルに描画(pctFileList, f, a, mFileRects, mListItemWDHT, False)
            Else
                Call zzリストの一セル枠を描画(pctFileList, mFileRects(a), a, -1, True)
            End If
            gggbol = zzWNDバー_四frmDlgFileOpeningMsg_Op(2)
        Next
        '************************************************************************************************************
        '2020/06/08   この時点で、一部のリスト画像ファイルが、存在しない場合もありうる。しかし、mn1画像リストのデザイン変更_Click() ですべて　メモリー内に読込み済みにしあるので、次回の再起動まではエラーにならない。
        '-----------------------------------------------------------------
        '現在のリストを設定する。もし　mCurList　が　mListMax　をオーバーしていれば　１　に戻す
        Dim idx As Integer
        If OldCur > mListMax Then idx = 1 Else idx = OldCur
        If mCurList > mListMax Then mCurList = 1
        If mCurList < 1 Then mCurList = 1
        gggbol = ooFileListDrag操作.aaマウスイベントを発生させて現在のリストを設定(idx, pctFileList, pctDrag, mCurClickWaku, mFileRects, mCurList, mファイル群の名前配列, mBmp変更済み, m使用中リストIDX, mCurBoxWaku, lblFile)
        '************************************************************************************************************
        gggbol = zzWNDバー_四frmDlgFileOpeningMsg_Op(3)
        mCurBoxWaku.Visible = True
        mCurClickWaku.Visible = True
        '-----------------------------------------------------------------
        Me.Cursor = Cursors.Default
        Me.Refresh()
        mBmp変更済み = mBmp変更済み Or True
    End Sub
    '***********************************************************************
    Private Sub mn00画像リスト削除モードにする_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00画像リスト削除モードにする.Click
        pctFileList.ContextMenuStrip = Nothing
        lbl削除モード.Visible = True
    End Sub
    Private Sub lbl削除モード_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lbl削除モード.Click
        lbl削除モード.Visible = False
        pctFileList.ContextMenuStrip = ContextMenuStrip1
    End Sub
    '***********************************************************************
    Private Sub mn500フォルダを開く_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn500フォルダを開く.Click
        Try
            If Not My.Computer.FileSystem.DirectoryExists(m画像ファイルフォルダ履歴) Then m画像ファイルフォルダ履歴 = My.Application.Info.DirectoryPath
            gggint = ⅩFileRunOrFolderShow(Me.Handle.ToInt32, 0, m画像ファイルフォルダ履歴)
        Catch
            MsgBox(ErrorToString())
        End Try
    End Sub
    '***********************************************************************
    Private Sub ContextMenuStrip1_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ContextMenuStrip1.Opening
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                mn00pop複数ファイルを登録.Enabled = (zz現在の登録枚数() < mListMax)
            Case gmDlgFileスイスイ用
                mn00pop複数ファイルを登録.Enabled = (zz現在の登録枚数() < mListMax) And ppスイスイフラフラ_いずれも停止している
        End Select
        Dim pt, pptt As Point
        Dim en As Boolean, msptidx As Integer
        pt = Control.MousePosition
        pptt = pctFileList.PointToClient(pt)
        msptidx = zzマウスポイントの_mFileRect_Index(pptt.X, pptt.Y)
        en = (msptidx > 0 And msptidx <> m使用中リストIDX)  'And mリスト内の選択ファイル <> p画像ファイル規定の内蔵画像)
        'qqqqq(CStr(mCurList))
        mn00pop選択画像で実行.Enabled = en
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                mn00pop選択画像を外す.Enabled = en
            Case gmDlgFileスイスイ用
                mn00pop選択画像を外す.Enabled = en And ppスイスイフラフラ_いずれも停止している
        End Select
    End Sub
    Private Sub mn00pop複数ファイルを登録_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00pop複数ファイルを登録.Click
        If (mDlgUserID = gmDlgFileスイスイ用) And ppスイスイフラフラ_いずれかあるいは両方_を実行中 Then Exit Sub
        Call mn00複数ファイルを登録_Click(Nothing, Nothing)
    End Sub
    Private Sub mn500popフォルダを開く_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn500popフォルダを開く.Click
        If (mDlgUserID = gmDlgFileスイスイ用) And ppスイスイフラフラ_いずれかあるいは両方_を実行中 Then Exit Sub
        Call mn500フォルダを開く_Click(Nothing, Nothing)
    End Sub
    Private Sub mn00pop選択画像で実行_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00pop選択画像で実行.Click
        Call mn00選択画像で実行_Click(Nothing, Nothing)
    End Sub
    Private Sub mn00pop選択画像を外す_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn00pop選択画像を外す.Click
        If (mDlgUserID = gmDlgFileスイスイ用) And ppスイスイフラフラ_いずれかあるいは両方_を実行中 Then Exit Sub
        Call mn00選択画像を外す_Click(Nothing, Nothing)
    End Sub
    '***********************************************************************
    Private Sub mn8suiyula_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8suiyula.Click
        'no op
    End Sub
    Private Sub mn8スイスイとユラユラを実行_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8スイスイとユラユラを実行.Click
        Call frmMain.mn8スイスイとユラユラを実行_Click(Nothing, Nothing)
    End Sub
    Private Sub mn8スイスイとユラユラすべて停止_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8スイスイとユラユラすべて停止.Click
        Call frmMain.mn8スイスイとユラユラすべて停止_Click(Nothing, Nothing)
    End Sub
    Private Sub mn8スイスイ実行_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8スイスイ実行.Click
        Call frmMain.mn8スイスイ実行_Click(Nothing, New System.EventArgs())
    End Sub
    Private Sub mn8スイスイ停止_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8スイスイ停止.Click
        Call frmMain.mn8スイスイ停止_Click(Nothing, New System.EventArgs())
    End Sub
    Private Sub mn8ユラユラ実行_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8ユラユラ実行.Click
        Call frmMain.mn8ユラユラ実行_Click(Nothing, New System.EventArgs())
    End Sub
    Private Sub mn8ユラユラ停止_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8ユラユラ停止.Click
        Call frmMain.mn8ユラユラ停止_Click(Nothing, New System.EventArgs())
    End Sub
    Private Sub mn8スイスイとユラユラを表示_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8スイスイとユラユラを表示.Click
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                'no op
            Case gmDlgFileスイスイ用
                gggstr = gAppEventMaker.MakeEventDlgスイスイとユラユラを表示消去(True)
        End Select
    End Sub
    Private Sub mn8スイスイ用カード型を設定_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8スイスイ用カード型を設定.Click
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                'no op
            Case gmDlgFileスイスイ用
                Call frmMain.mn8スイスイ用カード型を設定_Click(Nothing, Nothing)
        End Select
    End Sub
    Private Sub mn8このアプリを終了_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mn8このアプリを終了.Click
        If ⅩMsgBox_アプリ終了しますか(appアプリタイトル) Then Call frmMain.mn1gameこのアプリを終了_Click(Nothing, Nothing)
    End Sub

#End Region

#Region "コマンドイベント"
    '***********************************************************************
    Private Sub pctFileList_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles pctFileList.DragEnter
        If lbl削除モード.Visible = True Then Return
        Select Case mDlgUserID
            Case gmDlgFileゲーム用, gmDlgFileスイスイ用
                gggbol = ⅩOLEDragDropファイルイベント_Drag_Is_指定EXT_IN(e, gco拡張子集_画像)
        End Select
    End Sub
    '***********************************************************************
    Private Sub pctFileList_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles pctFileList.DragOver
        If lbl削除モード.Visible = True Then Return
        Select Case mDlgUserID
            Case gmDlgFileゲーム用, gmDlgFileスイスイ用
                gggbol = ⅩOLEDragDropファイルイベント_Drag_Is_指定EXT_IN(e, gco拡張子集_画像)
        End Select
    End Sub
    Private Sub pctFileList_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles pctFileList.DragDrop
        If lbl削除モード.Visible = True Then Return
        Dim wFolders_0_Ubound() As String = {""}, wFiles() As String = {""} : Dim wDrpX_inControl, wDrpY_inControl As Integer
        Select Case mDlgUserID
            Case gmDlgFileゲーム用, gmDlgFileスイスイ用
                If ⅩOLEDragDropファイルイベント(3, pctFileList, e, wFolders_0_Ubound, wFiles, wDrpX_inControl, wDrpY_inControl) Then
                    'qqqqq("wFolders_0_Ubound") : For a = 0 To UBound(wFolders_0_Ubound) : qqqqq(wFolders_0_Ubound(a)) : Next
                    'qqqqq("wFiles_0_Ubound") : For a = 0 To UBound(wFiles) : qqqqq(wFiles(a)) : Next
                    'qqqqq(CStr(wDrpX_inControl))
                    'qqqqq(CStr(wDrpY_inControl))
                End If
                Dim max As Integer = Ⅹ文配列をゼロベースから壱ベースにする(wFiles)
                gmFlag_On_OLEDropFile = True
                Dim addnum As Integer = zz複数ファイル画像をリストに追加(wFiles, wDrpX_inControl, wDrpY_inControl)
                If addnum > 0 Then
                    gggbol = zzリストへのドラドロ後の_ゲームスタートorスイスイ画像変更(wFiles(1))
                End If
                gmFlag_On_OLEDropFile = False
        End Select
    End Sub
    '***********************************************************************
    Private Sub pctFileList_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles pctFileList.DoubleClick
        Call ooFileListDrag操作.pctList_DblClick()
        'qqqqq "pctFileList_DblClick() from frmMain"
    End Sub
    Private Sub pctFileList_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pctFileList.MouseDown
        Call ooFileListDrag操作.pctList_MouseDown(e.Button, e.X, e.Y, mFileRects, mCurList)
    End Sub
    Private Sub pctFileList_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pctFileList.MouseMove
        If lbl削除モード.Visible Then Return
        Call ooFileListDrag操作.pctList_MouseMove(e.Button, e.X, e.Y, pctFileList, pctDrag, mFileRects, mCurList)
    End Sub
    Private Sub pctFileList_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pctFileList.MouseUp
        'qqqqq "pctFileList_MouseUp() from frmMain"
        '----------------------------------------------------------------------
        Dim wDblClickAfterUp, wMouseRightButtonUp, wDragMoveDone As Boolean
        Dim wシフトstepnum As Integer
        Dim mOldCurUseIDX As Integer = m使用中リストIDX
        Dim oldmCurList As Integer = mCurList
        Dim oldファイル As String = mファイル群の名前配列(m使用中リストIDX)
        Dim wRetIndexマウスポイント As Integer = 0
        '----------------------------------------------------------------------
        Call ooFileListDrag操作.pctList_MouseUp(wRetIndexマウスポイント, e.Button, e.X, e.Y, pctFileList, pctDrag, mCurClickWaku, mFileRects, mCurList, mファイル群の名前配列, mBmp変更済み, m使用中リストIDX, mCurBoxWaku, wMouseRightButtonUp, wDblClickAfterUp, , wDragMoveDone, , , wシフトstepnum, lblFile, True)
        '----------------------------------------------------------------------
        If lbl削除モード.Visible Then  '削除モード
            If wRetIndexマウスポイント > 0 And wRetIndexマウスポイント <= UBound(mファイル群の名前配列) Then
                If mファイル群の名前配列(wRetIndexマウスポイント) <> "" And (zz現在の登録枚数() > 1) Then Call mn00選択画像を外す_Click(Nothing, Nothing)
                If (zz現在の登録枚数() = 1) Then Call lbl削除モード_Click(Nothing, Nothing)
                Exit Sub
            End If
        End If
        '----------------------------------------------------------------------
        If mCurList > 0 And mCurList <= UBound(mファイル群の名前配列) Then
            Dim ファイル As String = mファイル群の名前配列(mCurList)
            If True = zzアプリ規定の内蔵画像ではなく_読み込めないあるいは存在しない画像ファイル(ファイル, False, "") Then
                If ContextMenuStrip1.Visible Then ContextMenuStrip1.Close()
                If m使用中リストIDX = mCurList Then
                    Call ⅩMsgBox_OK_注意("""" & ファイル & """" & gggCR2 & "このファイルの画像は使用されていますが。" & gggCR2 & "ファイルそのものは、移動あるいは削除されています。" & gggCR2 & "画像リストファイルの再設定　を実行してください。")
                Else
                    If ⅩMsgBox_Yes_TRUE_No_FALSE("このファイルは存在しません", """" & ファイル & """" & gggCR2 & "このファイルは存在しません。" & gggCR2 & "あるいは、現在の状態では使用できないファイルです。" & gggCR2 & "画像リストでの、このファイルの登録を削除しますか？") Then
                        gggbol = zzリストの選択画像を外す()
                    Else
                        m使用中リストIDX = mOldCurUseIDX
                        mCurList = oldmCurList
                        gggstr = aa画像ファイル新規設定後のリスト選択表示処理(oldファイル)
                    End If
                End If
                Exit Sub
            End If
        End If
        '----------------------------------------------------------------------
        If wMouseRightButtonUp Then
            Call mn000画像用ファイル_Click_COM(mn00pop複数ファイルを登録, mn00pop選択画像で実行, mn00pop選択画像を外す)
        ElseIf wDblClickAfterUp Then
            m使用中リストIDX = mCurList
            Call mn00選択画像で実行_Click(mn00選択画像で実行, New System.EventArgs())
        ElseIf wDragMoveDone And wシフトstepnum <> 0 Then
            '??????????????????
            ''If mOldCurUseIDX <> m使用中リストIDX And mループ実行中 Then
            '    '    'qqqqq "mOldCurUseIDX = " + CStr(mOldCurUseIDX) + ",  m使用中リストIDX = " + CStr(m使用中リストIDX)
            ''End If
            ''no op 2019/07/26

        End If
        'qqqqq "New = " + CStr(mCurList) + "
        'qqqqq "mCurList = 1 / wDragMoveDone"
    End Sub
    '***********************************************************************
#End Region

#Region "プロパティ"
    '***********************************************************************
    Private Const c画像サイズ設定最大制限値 As String = "画像サイズ設定最大制限値"
    '***********************************************************************
    Private Property pINI画像サイズ設定最大制限値() As String
        'gcoプロパiniWR
        Get
            Const cut As String = ","
            Dim sss As String = CStr(mBmpMaxWD) + cut + CStr(mBmpMaxHT) + cut
            Return ⅩIniデーター文_RW(gcoプロパiniWR, c画像サイズ設定最大制限値, sss)
        End Get
        'gcoプロパiniRD
        Set(ByVal value As String)
            Const cut As String = ","
            Dim sss As String = ⅩIniデーター文_RW(gcoプロパiniRD, c画像サイズ設定最大制限値, value)
            Dim ary() As String = {""}
            Dim m As Integer
            m = Ⅹ文をカットして配列にする(sss, cut, ary)
            If m = 2 Then
                mBmpMaxWD = Ⅹ数値範囲Int(cBmpMinWD, cBmpMaxWD, CInt(ary(1)))
                mBmpMaxHT = Ⅹ数値範囲Int(cBmpMinHT, cBmpMaxHT, CInt(ary(2)))
            End If
        End Set
    End Property
    '***********************************************************************
    Private Const cリストサイズデーター As String = "リストサイズデーター"
    '***********************************************************************
    Private Property pINIリストサイズデーター() As String
        'gcoプロパiniWR
        Get
            Const cut As String = ","
            Dim sss As String = CStr(mListItemWDHT) + cut + CStr(mListColX) + cut + CStr(mListLowY) + cut
            Return ⅩIniデーター文_RW(gcoプロパiniWR, cリストサイズデーター, sss)
        End Get
        'gcoプロパiniRD
        Set(ByVal value As String)
            Const cut As String = ","
            Dim sss As String = ⅩIniデーター文_RW(gcoプロパiniRD, cリストサイズデーター, value)
            Dim ary() As String = {""}
            Dim m As Integer
            m = Ⅹ文をカットして配列にする(sss, cut, ary)
            If m = 3 Then
                mListItemWDHT = Ⅹ数値範囲Int(66, 200, CInt(ary(1)))
                mListColX = Ⅹ数値範囲Int(6, 16, CInt(ary(2)))
                mListLowY = Ⅹ数値範囲Int(4, 12, CInt(ary(3)))
                mListMax = mListColX * mListLowY
                mListPichXY = mListItemWDHT + cListSpaceXY
            End If
        End Set
    End Property
    '***********************************************************************
    Private Const c画像ファイルフォルダ履歴 As String = "画像ファイルフォルダ履歴"
    '***********************************************************************
    Private Property pINI画像ファイルフォルダ履歴() As String
        'gcoプロパiniWR
        Get
            Return ⅩIniデーター文_RW(gcoプロパiniWR, c画像ファイルフォルダ履歴, m画像ファイルフォルダ履歴)
        End Get
        'gcoプロパiniRD
        Set(ByVal value As String)
            m画像ファイルフォルダ履歴 = ⅩIniデーター文_RW(gcoプロパiniRD, c画像ファイルフォルダ履歴, value)
        End Set
    End Property
    '***********************************************************************
    Private Const c使用中リストIDX As String = "使用中リストIDX"
    '***********************************************************************
    Private Property pINI使用中リストIDX() As String
        'gcoプロパiniWR
        Get
            Return ⅩIniデーター文_RW(gcoプロパiniWR, c使用中リストIDX, CStr(m使用中リストIDX))
        End Get
        'gcoプロパiniRD
        Set(ByVal value As String)
            m使用中リストIDX = CInt(ⅩIniデーター文_RW(gcoプロパiniRD, c使用中リストIDX, value))
        End Set
    End Property
    '***********************************************************************
    Private Const cファイル群の名前配列 As String = "ファイル群の名前配列"
    '***********************************************************************
    Private Property pINIファイル群の名前配列() As String
        'gcoプロパiniWR
        Get
            Const cut As String = "|||" : Dim 値 As String = ""
            Dim ary() As String = {""}
            gggbol = Ⅹ文配列のコピー(ary, mファイル群の名前配列, True)
            値 = Ⅹ文を配列から作成(ary, cut)
            Return ⅩIniデーター文_RW(gcoプロパiniWR, cファイル群の名前配列, 値)
        End Get
        'gcoプロパiniRD
        Set(ByVal value As String)
            Const cut As String = "|||" : Dim 値 As String = ""
            値 = ⅩIniデーター文_RW(gcoプロパiniRD, cファイル群の名前配列, value)
            Dim ary() As String = {""}
            Dim m As Integer
            m = Ⅹ文をカットして配列にする(値, cut, ary)
            gggbol = Ⅹ文配列のコピー_Not_ReDim_受け配列(mファイル群の名前配列, ary)
        End Set
    End Property
    '***********************************************************************
    Friend Sub tim切り替えタイマー_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tim切り替えタイマー.Tick
        '-----------------------------------------------------
        'このウインドウが表示されている間は、タイマーの　カウントは停止させる
        Static mmmm As Integer
        '-----------------------------------------------------------------
        '-----------------------------------------------------------------
        'no op ---- 2023/04/16  frmMain.WindowState がアイコン化されていれば、画像切り替えはしない。できない。
        If frmMain.WindowState = FormWindowState.Minimized Then
            Return
        End If
        '-----------------------------------------------------------------
        '-----------------------------------------------------------------
        If Me.Visible = False Then
            If (mDlgUserID = gmDlgFileゲーム用) And gmゲーム実行中_in_MouseEvent Then
                'no op ---- 2022/08/10  ゲーム中にマウスでカードを移動しているので、画像切り替えはしない。
                'qqqqq("ゲーム中にマウスでカードを移動--タイマー_Tick()")

            Else
                '-----------------------------------------------------------------
                'mmmm = mmmm + 1 : qqqqq(CStr(mmmm) + " 四frmDlgPctFilesList - tim切り替えタイマー_Tick()")
                '-----------------------------------------------------------------
                Dim wIs満期 As Boolean = False
                RaiseEvent 画像ファイルの切替タイマー一秒ごとの通知(wIs満期)
                If wIs満期 Then
                    mmmm = 0
                    Dim rNextファイル As String, rCurファイル As String, idx As Integer, wChangeDone As Boolean
                    rCurファイル = mファイル群の名前配列(m使用中リストIDX)
                    If rCurファイル = "" Then rCurファイル = p画像ファイル規定の内蔵画像
                    rNextファイル = p画像ファイル現在使用_の_次のファイル名_エラーなら一番へ(idx)

                    'qqqqq("RaiseEvent 画像ファイルの切替タイマー()")

                    RaiseEvent 画像ファイルの切替タイマー(rCurファイル, rNextファイル, wChangeDone)

                    If wChangeDone Then
                        frmMain.Refresh()    '必要
                        'qqqqq(CStr(m使用中リストIDX))
                    End If
                End If
            End If
        End If
    End Sub
    '***********************************************************************
    Friend ReadOnly Property p画像ファイル現在使用() As String
        Get
            Dim a As Integer = m使用中リストIDX
            If a < 1 Or a > UBound(mファイル群の名前配列) Then Return p画像ファイル規定の内蔵画像
            Dim fff As String = mファイル群の名前配列(a)
            If Ⅹファイルは存在(fff) Then Return fff Else Return p画像ファイル規定の内蔵画像
        End Get
    End Property
    '***********************************************************************
    Private ReadOnly Property p画像ファイル現在使用と同じ(ByVal rChkFile As String) As Boolean
        Get
            Dim a As Integer = m使用中リストIDX
            If a < 1 Or a > UBound(mファイル群の名前配列) Then Return False
            Return (mファイル群の名前配列(a) = rChkFile)
        End Get
    End Property
    '***********************************************************************
    Private Function p画像ファイル現在使用_の_次のファイル名_エラーなら一番へ(ByRef wNewIndex As Integer) As String
        Dim a As Integer = m使用中リストIDX + 1
        If a < 1 Or a > UBound(mファイル群の名前配列) Then
            a = 1
        ElseIf mファイル群の名前配列(a) = "" Then
            a = 1
        End If
        wNewIndex = a
        Return mファイル群の名前配列(wNewIndex)
    End Function
    '***********************************************************************
    Private Function p画像ファイル現在使用_の_次のファイル名_エラーなら一番へ(ByVal rFile As String, ByRef wNewIndex As Integer) As String
        Dim a As Integer = 1 + zz選択ファイル名からインデックス(rFile)
        If a < 1 Or a > UBound(mファイル群の名前配列) Then
            a = 1
        ElseIf mファイル群の名前配列(a) = "" Then
            a = 1
        End If
        wNewIndex = a
        Return mファイル群の名前配列(wNewIndex)
    End Function
    '**********************************************************************
    Private ReadOnly Property p画像ファイル規定の内蔵画像() As String
        Get
            Return "◆アプリ規定の内蔵画像◆"
        End Get
    End Property
    '***********************************************************************
    Friend Property pリストの配色背景() As Integer
        Get
            Return CInt(pリストの配色背景_RW(gcoプロパGet))
        End Get
        Set(ByVal Value As Integer)
            Call pリストの配色背景_RW(gcoプロパLet, CStr(Value))
        End Set
    End Property
    Friend Function pリストの配色背景_RW(ByRef プロパコマンド As Integer, Optional ByRef s As String = "") As String
        Const PropName As String = "pリストの配色背景" : Const 値DEF As Integer = &HD0FFD0& : Static 値 As Integer
        Select Case プロパコマンド
            Case gcoプロパ名 : Return PropName
            Case gcoプロパ初期化 : 値 = 値DEF
            Case gcoプロパ規定値 : Return CStr(値DEF)
            Case gcoプロパGet : Return CStr(値)
            Case gcoプロパLet : 値 = CInt(Ⅹ色の値の検査修正値(Val(s)))
            Case gcoプロパiniWR : Return ⅩIniデーター文_RW(gcoプロパiniWR, PropName, CStr(値))
            Case gcoプロパiniRD : 値 = CInt(ⅩIniデーター文_RW(gcoプロパiniRD, PropName, s))
        End Select
        Return ""
    End Function
    '***********************************************************************
    Friend Property pリストの配色枠の色() As Integer
        Get
            Return CInt(pリストの配色枠の色_RW(gcoプロパGet))
        End Get
        Set(ByVal Value As Integer)
            Call pリストの配色枠の色_RW(gcoプロパLet, CStr(Value))
        End Set
    End Property
    Friend Function pリストの配色枠の色_RW(ByRef プロパコマンド As Integer, Optional ByRef s As String = "") As String
        Const PropName As String = "pリストの配色枠の色" : Const 値DEF As Integer = &H0& : Static 値 As Integer
        Select Case プロパコマンド
            Case gcoプロパ名 : Return PropName
            Case gcoプロパ初期化 : 値 = 値DEF
            Case gcoプロパ規定値 : Return CStr(値DEF)
            Case gcoプロパGet : Return CStr(値)
            Case gcoプロパLet : 値 = CInt(Ⅹ色の値の検査修正値(Val(s)))
            Case gcoプロパiniWR : Return ⅩIniデーター文_RW(gcoプロパiniWR, PropName, CStr(値))
            Case gcoプロパiniRD : 値 = CInt(ⅩIniデーター文_RW(gcoプロパiniRD, PropName, s))
        End Select
        Return ""
    End Function
    '***********************************************************************
    Private pファイル選択でダイアログ閉じるVAL As Boolean         '2023/03/18 add new
    Friend Property pファイル選択でダイアログ閉じる() As Boolean  '2023/03/18 add new
        Get
            Return pファイル選択でダイアログ閉じるVAL
        End Get
        Set(ByVal Value As Boolean)
            pファイル選択でダイアログ閉じるVAL = Value
        End Set
    End Property
    '***********************************************************************
#End Region

#Region "aa外部とのインタフェイス"
    '***********************************************************************
    Friend Function aaプロパティ初期化_INI読出し書込みsub(ByRef プロパコマンド As Integer, ByRef ini配列() As String, ByRef CurIDX As Integer) As Boolean
        Dim AryMax As Integer = UBound(ini配列)
        Dim ssss As String, hedend As String = "*********************" + Me.Text + "*********************"
        Dim a As Integer, m As Integer
        Select Case プロパコマンド
            Case gcoプロパ初期化
                '-----------------------------------------------
                '宣言で規定値を設定済み　重複して定義しないように
                'mListItemWDHT = 100 
                'mListColX = 7
                'mListLowY = 5
                'mListMax = mListColX * mListLowY
                'mListPichXY = 110
                'mBmpMaxWD = 2000
                'mBmpMaxHT = 1500
                'm使用中リストIDX = 1
                'ReDim mファイル群の名前配列(200)
                '宣言で規定値を設定済み　重複して定義しないように
                '-----------------------------------------------
                mファイル群の名前配列(1) = p画像ファイル規定の内蔵画像
                m画像ファイルフォルダ履歴 = GMCOMアプリフォルダ("")
                Call pリストの配色枠の色_RW(プロパコマンド)
                Call pリストの配色背景_RW(プロパコマンド)
                '-----------------------------------------------
                '2022/06/24  それぞのユーザーが、任意の背景色を選択できるようにする。
                If mDlgUser指定背景色 >= 0 Then pリストの配色背景 = mDlgUser指定背景色 'mDlgUserID それぞれに背景色を指定できる。
                mDlgUser指定背景色 = -1
                '-----------------------------------------------
            Case gcoプロパiniRD
                For m = 1 To AryMax
                    If ini配列(m) = hedend Then Exit For
                Next
                If m < AryMax Then
                    For a = m + 1 To AryMax
                        ssss = ini配列(a)
                        If ssss = hedend Then
                            CurIDX = a
                            Exit For
                        ElseIf InStr(ssss, cリストサイズデーター) = 1 Then
                            pINIリストサイズデーター = ssss
                        ElseIf InStr(ssss, c画像サイズ設定最大制限値) = 1 Then
                            pINI画像サイズ設定最大制限値 = ssss
                        ElseIf InStr(ssss, c使用中リストIDX) = 1 Then
                            pINI使用中リストIDX = ssss
                        ElseIf InStr(ssss, cファイル群の名前配列) = 1 Then
                            pINIファイル群の名前配列 = ssss
                        ElseIf InStr(ssss, c画像ファイルフォルダ履歴) = 1 Then
                            pINI画像ファイルフォルダ履歴 = ssss
                        ElseIf InStr(ssss, pリストの配色枠の色_RW(gcoプロパ名)) = 1 Then
                            Call pリストの配色枠の色_RW(プロパコマンド, ssss)
                        ElseIf InStr(ssss, pリストの配色背景_RW(gcoプロパ名)) = 1 Then
                            Call pリストの配色背景_RW(プロパコマンド, ssss)
                        End If
                    Next
                End If
                'For a = 1 To 5 : qqqqq(mファイル群の名前配列(a)) : Next

            Case gcoプロパiniWR
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = hedend Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = pINIリストサイズデーター Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = pINI画像サイズ設定最大制限値 Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = pINI使用中リストIDX Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = pINIファイル群の名前配列 Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = pINI画像ファイルフォルダ履歴 Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = pリストの配色枠の色_RW(gcoプロパiniWR) Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = pリストの配色背景_RW(gcoプロパiniWR) Else Return True
                CurIDX = CurIDX + 1 : If CurIDX <= AryMax Then ini配列(CurIDX) = hedend Else Return True

        End Select

        Return True
    End Function
    '***********************************************************************
    Friend Function aa画像ファイルリストコピー(ByRef wwファイル群の名前配列() As String, ByRef ww使用中リストIDX As Integer) As Integer
        'wwファイル群の名前配列(n) = ""  なら  Redim preserve wwファイル群の名前配列(n)
        gggbol = Ⅹ文配列のコピー(wwファイル群の名前配列, mファイル群の名前配列, True)
        ww使用中リストIDX = m使用中リストIDX
        Return UBound(wwファイル群の名前配列)
    End Function
    '***********************************************************************
    Friend Function aa画像ファイルオープン_into_ImageBox(ByRef ファイル As String, ByRef Img返す As Image, ByRef wPctCurBmp縦横比率 As Single) As String
        '-------------------------------------------------------------------------------------
        Dim r規定の内蔵画像 As String = ""
        If ファイル = "" Or ファイル = p画像ファイル規定の内蔵画像 Then r規定の内蔵画像 = p画像ファイル規定の内蔵画像
        Return gmComFileBmp.aa画像ファイルオープン_Ret_CopyImg(ファイル, Img返す, mBmpMaxWD, mBmpMaxHT, r規定の内蔵画像, pctAppDef.Image, wPctCurBmp縦横比率)
        '-------------------------------------------------------------------------------------
    End Function
    '***********************************************************************
    Friend Function aa画像ファイルオープン_into_ImageBox_IfError_SetNextFile_自動的に(ByRef ファイル As String, ByRef Img返す As Image, ByRef wPctCurBmp縦横比率 As Single, ByRef ww使用中リストIDX As Integer) As String
        Dim wNewIndex As Integer : Dim OpenFiileOK As String = ""
        Dim fileファイル As String = ファイル : Dim f As String
        Do
            OpenFiileOK = aa画像ファイルオープン_into_ImageBox(fileファイル, Img返す, wPctCurBmp縦横比率)
            If OpenFiileOK = "" Then
                Call ⅩMsgBox_OK_注意("""" & fileファイル & """" & gggCR2 & "このファイルは存在していません。" & gggCR2 & Ⅹカッコで囲む和文用(Me.Text, " ") & "  ダイアログで、" & gggCR2 & "画像リストファイルの再設定　を実行してください。" & gggCR2 & "★画像リストの次のファイルを使用します。")
                f = fileファイル
                fileファイル = p画像ファイル現在使用_の_次のファイル名_エラーなら一番へ(f, wNewIndex)
            Else
                Exit Do
            End If
        Loop
        m使用中リストIDX = zz選択ファイル名からインデックス(fileファイル)
        ww使用中リストIDX = m使用中リストIDX
        Return OpenFiileOK
    End Function
    '***********************************************************************
    Friend Function aa画像ファイル新規設定後のリスト選択表示処理(ByVal rw画像ファイルNEW As String) As String
        'qqqqq(CStr(m使用中リストIDX))
        Dim fff As String = zz画像ファイル名取得_エラーなら_規定の内蔵画像に設定__m使用中リストIDX_と_mCurList_を設定(rw画像ファイルNEW)
        Dim a As Integer = m使用中リストIDX
        gggbol = ooFileListDrag操作.aaマウスイベントを発生させて現在のリストを設定(a, pctFileList, pctDrag, mCurClickWaku, mFileRects, mCurList, mファイル群の名前配列, mBmp変更済み, m使用中リストIDX, mCurBoxWaku, lblFile)
        gggint = ooFileListDrag操作.aaCurUseIDX_セル枠設定(pctFileList, mFileRects(m使用中リストIDX), mCurBoxWaku)
        Return mファイル群の名前配列(m使用中リストIDX)
    End Function
    '***********************************************************************
    Friend Function aaファイル画像一枚をリストに追加_on_DRAG_DROP_in_frmMain(ByRef rFiles() As String) As Boolean
        Dim a, b As Integer
        Dim newfile As String = ""
        For a = 1 To UBound(rFiles)
            If Not zzアプリ規定の内蔵画像ではなく_読み込めないあるいは存在しない画像ファイル(rFiles(a), True, "") Then
                If Ⅹ文を配列から探す(mファイル群の名前配列, rFiles(a)) = 0 Then
                    newfile = rFiles(a) : Exit For
                End If
            End If
        Next
        If newfile = "" Then
            For a = 1 To UBound(rFiles)
                b = Ⅹ文を配列から探す(mファイル群の名前配列, rFiles(a))
                If b > 0 Then
                    newfile = mファイル群の名前配列(b) : Exit For
                End If
            Next
            If newfile = "" Then Return False
        Else
            Dim files(1) As String, dropx As Integer, dropy As Integer
            files(1) = newfile
            If mDlgUserID = gmDlgFileゲーム用 Then
                dropx = -1 : dropy = -1
            ElseIf mDlgUserID = gmDlgFileスイスイ用 Then
                a = m使用中リストIDX + 1
                If a > UBound(mファイル群の名前配列) Then a = 1
                dropx = mFileRects(a).lll + 5
                dropy = mFileRects(a).ttt + 5
            Else
                Return False
            End If
            If (1 <> zz複数ファイル画像をリストに追加(files, dropx, dropy)) Then Return False
        End If
        Return zzリストへのドラドロ後の_ゲームスタートorスイスイ画像変更(newfile)
    End Function
    '***********************************************************************
#End Region

#Region "zzローカルヘルパー"
    '***********************************************************************
    Private Function zzWNDバー_四frmDlgFileOpeningMsg_Op(ByVal stt1_mid2_stp3 As Integer) As Boolean
        '読み込み数が多い場合に　四frmDlgFileOpeningMsg　ダイアログを表示し、進行状況を表示する。
        '**********************************************************
        If mDoEventsCall Then
            'qqqqq("mDoEventsCall  zz画像ファイルをまとめて_ooファイル画像庫_に読込む()")
            Return False
        End If
        '**********************************************************
        Static 処理済み枚数 As Integer = 0
        Dim 処理すべき枚数 As Integer = zz現在の登録枚数()

        Select Case stt1_mid2_stp3
            Case 1
                ooWNDバー = New 四frmDlgFileOpeningMsg
                If ooWNDバー IsNot Nothing Then
                    ooWNDバー.aaDlgShow(Me)
                    frmMain.Enabled = False
                    If Me.Visible Then
                        Me.Cursor = Cursors.WaitCursor
                        Me.Enabled = False
                        Me.Refresh()
                    End If
                End If

            Case 2
                処理済み枚数 = 処理済み枚数 + 1
                If ooWNDバー IsNot Nothing Then
                    Dim 処理割合 As Single = CSng(処理済み枚数) / CSng(処理すべき枚数)
                    If 処理割合 > 1.0 Then
                        処理割合 = 1.0
                    End If
                    gggbol = ooWNDバー.aa現在の処理割合(処理割合)
                    ooWNDバー.Refresh()
                    '************************************************
                    mDoEventsCall = True : System.Windows.Forms.Application.DoEvents() : mDoEventsCall = False
                    '************************************************
                End If

            Case 3
                If ooWNDバー IsNot Nothing Then
                    ooWNDバー.Refresh()
                    ooWNDバー.Close()
                    ooWNDバー.Dispose()
                    ooWNDバー = Nothing
                End If
                frmMain.Enabled = True
                If Me.Visible Then
                    Me.Cursor = Cursors.Default
                    Me.Enabled = True
                    Me.Refresh()
                End If
                mDoEventsCall = False
        End Select
        Return True
    End Function
    '***********************************************************************
    Private Function zz画像ファイル名取得_エラーなら_規定の内蔵画像に設定__m使用中リストIDX_と_mCurList_を設定(ByVal filefullpath As String) As String
        '------------------------------------------------------
        Dim RETfile As String = ""
        Dim f As String = filefullpath
        If f = p画像ファイル規定の内蔵画像 Then
            RETfile = f
        ElseIf ⅩファイルはPictureBoxで読み込める画像でファイルシステムに存在する(f) Then
            RETfile = f
        ElseIf m使用中リストIDX > 0 And m使用中リストIDX <= UBound(mファイル群の名前配列) Then
            f = mファイル群の名前配列(m使用中リストIDX)
            If f = p画像ファイル規定の内蔵画像 Then
                RETfile = f
            ElseIf ⅩファイルはPictureBoxで読み込める画像でファイルシステムに存在する(f) Then
                RETfile = f
            Else
                RETfile = ""
            End If
        End If
        If RETfile = "" Then
            RETfile = p画像ファイル規定の内蔵画像
        End If
        '------------------------------------------------------
        m使用中リストIDX = zz選択ファイル名からインデックス(RETfile)
        If m使用中リストIDX = 0 Then
            m使用中リストIDX = 1
            mファイル群の名前配列(1) = RETfile
        End If
        '------------------------------------------------------
        If mCurList < 1 Or mCurList > UBound(mファイル群の名前配列) Then
            mCurList = m使用中リストIDX
        ElseIf mファイル群の名前配列(mCurList) = "" Then
            mCurList = m使用中リストIDX
        End If
        Return RETfile
        '------------------------------------------------------
    End Function
    '***********************************************************************
    Private Function zz複数ファイル画像をリストに追加(ByRef rFiles() As String, ByRef rDropX As Integer, ByRef rDropY As Integer) As Integer
        '---------------------------------------------------------------------------
        Static staDoEventsCall As Boolean
        '---------------------------------------------------------------------------
        Dim NewFile() As String = {""}, maxold As Integer, max As Integer, a As Integer : Dim 現在の登録枚数 As Integer = zz現在の登録枚数()
        '---------------------------------------------------------------------------
        Dim oldファイル群の名前配列() As String = {""} : Dim リスト描画IDX As Integer : Dim DoEventsCallが必要 As Boolean
        Dim AddFileCount As Integer = 0
        '---------------------------------------------------------------------------
        If staDoEventsCall Then Return 0
        '---------------------------------------------------------------------------
        If 現在の登録枚数 = mListMax Then
            MsgBox("リスト内に追加できるスペースはありません。" & gggCR2 & "リストの空きスペース数を増やしてください。", 64, "リストの空きスペース数を増やしてください。")
            Return 0
        End If
        '-----------------------------------------------------------------------
        gggbol = Ⅹ文配列のコピー(NewFile, rFiles, True)
        maxold = UBound(NewFile)
        For a = 1 To UBound(NewFile)
            If Ⅹ文を配列から探す(mファイル群の名前配列, NewFile(a)) > 0 Then NewFile(a) = ""
        Next
        max = Ⅹ文配列の空の要素を削除する(NewFile, True, True)
        '-----------------------------------------------------------------------
        If max < maxold Then
            If max = 0 Then
                MsgBox("選択したファイルのすべてが、リスト内に存在しています。", 64, "選択ファイルすべてが存在します")
            Else
                MsgBox("選択ファイルの一部は、リスト内に存在しています。" & gggCR2 & "それらのファイルは登録されません。", 64, "一部の選択ファイルが存在しています")
            End If
        End If
        '-----------------------------------------------------------------------
        If max < 1 Then Return 0
        '-----------------------------------------------------------------------
        max = mListMax - 現在の登録枚数
        If max < UBound(NewFile) Then
            ReDim Preserve NewFile(a)
            Dim ssss As String = IIf(mListMax < c画像庫最大画数, "リストのサイズを大きくできれば、さらに登録できます。", "リストは現在の登録数サイズ以上に拡張できません。")
            MsgBox("選択ファイルの数が多いので、" & gggCR2 & "現在のリストに全てのファイルは登録できません。" & gggCR2 & ssss, 64, "一部の選択ファイルは登録できません")
        End If
        '-----------------------------------------------------------------------
        Dim DropAddPosIDX As Integer = 0
        If rDropX < 0 Then
            DropAddPosIDX = 現在の登録枚数 + 1
            gmFlag_On_OLEDropFile = False
        Else
            For a = 1 To 現在の登録枚数
                With mFileRects(a)
                    If rDropX >= .lll And rDropY >= .ttt And rDropX < .lll + mListPichXY And rDropY < .ttt + mListPichXY Then
                        DropAddPosIDX = a : Exit For
                    End If
                End With
            Next
            gmFlag_On_OLEDropFile = True
        End If
        If DropAddPosIDX > 現在の登録枚数 Then
            DropAddPosIDX = 現在の登録枚数 + 1
        ElseIf DropAddPosIDX = 0 Then
            DropAddPosIDX = 現在の登録枚数 + 1
        ElseIf DropAddPosIDX = 1 Then
            DropAddPosIDX = 2
        ElseIf DropAddPosIDX > mListMax Then
            DropAddPosIDX = mListMax
        End If
        OLEDropFilesTopindex = 0
        mCurBoxWaku.Visible = (Not gmFlag_On_OLEDropFile)
        '***************************************************************************
        If Not Ⅹ文配列のコピー(oldファイル群の名前配列, mファイル群の名前配列) Then GoTo ExitFunctionPost
        '***************************************************************************
        'For a = 1 To UBound(mファイル群の名前配列()): qqqqq mファイル群の名前配列(a): Next
        '***************************************************************************
        Dim fff As String
        If NewFile(1) <> "" Then
            max = UBound(NewFile)
            If max = 1 Then '
                fff = NewFile(1)
                '指定されたファイル NewFile(1) が存在しない場合の対策
                If zzアプリ規定の内蔵画像ではなく_読み込めないあるいは存在しない画像ファイル(fff, True, "") Then
                    'リストに存在していればそれを削除
                    a = Ⅹ文を配列から探す(mファイル群の名前配列, fff)
                    If a > 0 Then
                        mCurList = a : Call zzリストの選択画像を外す()
                    End If
                    NewFile(1) = "" : GoTo ExitFunctionPost
                End If
            End If
            '---------------------------------------------------------------------------
            DoEventsCallが必要 = True
            If DoEventsCallが必要 Then
                'DoEventsCallのために_frmMain_と_Me_をロックする
                frmMain.Enabled = False
                If Me.Visible Then Me.Enabled = False
                Me.Cursor = Cursors.WaitCursor
            End If
            '---------------------------------------------------------------------------
            Dim old_m使用中リストIDX As Integer = m使用中リストIDX
            Dim oldFile As String = mファイル群の名前配列(m使用中リストIDX)
            Dim 読めない画像がある As Boolean = False
            For a = 1 To max
                fff = NewFile(a)
                '---------------------------------------------------------------------------
                If "" <> aa画像ファイルオープン_into_ImageBox(fff, mImg現在のファイル, pctCurBmp縦横比率) Then
                    '---------------------------------------------------------------------------
                    リスト描画IDX = 0
                    If max = 1 And (Not gmFlag_On_OLEDropFile) Then
                        リスト描画IDX = 現在の登録枚数 + 1
                        mファイル群の名前配列(リスト描画IDX) = fff
                    ElseIf gmFlag_On_OLEDropFile Then
                        If DropAddPosIDX = 0 Then DropAddPosIDX = 1

                        Call ooFileListDrag操作.aaファイルリストシフト移動(mListMax, DropAddPosIDX, -1, pctFileList, mFileRects, mファイル群の名前配列, m使用中リストIDX, mCurBoxWaku)
                        リスト描画IDX = DropAddPosIDX
                        mファイル群の名前配列(DropAddPosIDX) = fff
                        If a = 1 Then
                            m画像ファイルフォルダ履歴 = Ⅹフルパス名からフォルダパス名あるいは親フォルダパス名を得る(fff)
                            OLEDropFilesTopindex = DropAddPosIDX
                        End If
                        DropAddPosIDX = DropAddPosIDX + 1
                    Else
                        リスト描画IDX = 現在の登録枚数 + a
                        mファイル群の名前配列(リスト描画IDX) = fff
                    End If
                    '---------------------------------------------------------------------------
                    If リスト描画IDX > 0 Then
                        Call zzリストの一セルに描画(pctFileList, "@usecur@", リスト描画IDX, mFileRects, mListItemWDHT, True)
                    End If
                    If max > 1 Then 'リスト画像の登録追加のみで、現在の画像は変更しない。
                        If mファイル群の名前配列(mListMax) <> "" Then Exit For
                    End If
                    '---------------------------------------------------------------------------
                    '2021/07/24 new
                    If DoEventsCallが必要 Then
                        staDoEventsCall = True : Application.DoEvents() : staDoEventsCall = False
                    End If
                    '---------------------------------------------------------------------------
                    AddFileCount = AddFileCount + 1
                Else
                    読めない画像がある = True
                    NewFile(a) = ""
                End If
                '---------------------------------------------------------------------------
            Next
            '---------------------------------------------------------------------------
            If gmFlag_On_OLEDropFile Then
                If old_m使用中リストIDX <> m使用中リストIDX Then
                    m使用中リストIDX = zz選択ファイル名からインデックス(oldFile) '''''''''''''''p画像ファイル現在使用Index()
                    gggbol = ooFileListDrag操作.aaCurUseIDX_セル枠設定(pctFileList, mFileRects(m使用中リストIDX), mCurBoxWaku)
                End If
            End If
            '---------------------------------------------------------------------------
            If 読めない画像がある Then MsgBox("ファイルの登録作業で、読み込めないファイルがありました。")
            '---------------------------------------------------------------------------
            If DoEventsCallが必要 Then
                'DoEventsCallのための_frmMain_と_Me_のロックを解除
                frmMain.Enabled = True
                If Me.Visible Then Me.Enabled = True
                Me.Cursor = Cursors.Default
            End If
            '---------------------------------------------------------------------------
        End If
        '---------------------------------------------------------
ExitFunctionPost:
        mBmp変更済み = mBmp変更済み Or (Not Ⅹ文配列全体の比較(oldファイル群の名前配列, mファイル群の名前配列, True))
        'qqqqq "mBmp変更済み = " + CStr(mBmp変更済み)
        'qqqqq "pctCurBmp WD/HT = " + CStr(pctCurBmp.Width) + "   " + CStr(pctCurBmp.Height)
        OLEDropFilesTopindex = 0
        DropAddPosIDX = 0
        gmFlag_On_OLEDropFile = False
        staDoEventsCall = False
        mCurBoxWaku.Visible = (Not gmFlag_On_OLEDropFile)
        Return AddFileCount
    End Function
    '***********************************************************************
    Private Function zzリストへのドラドロ後の_ゲームスタートorスイスイ画像変更(ByVal newfile As String) As Boolean
        qqqqq("call zzリストへのドラドロ後の_ゲームスタートorスイスイ画像変更()")
        Dim a As Integer
        a = zz選択ファイル名からインデックス(newfile)
        If a > 0 Then
            mCurList = a
            Call mn00選択画像で実行_Click(Nothing, Nothing)        'ゲームスタートorスイスイ画像変更
            Return True
        End If
        Return False
    End Function
    '***********************************************************************
    Private Function zzリストの一セル枠を描画(ByRef pct As PictureBox, ByRef rc As RECT, ByRef idx As Integer, ByRef rリストセル枠色 As Integer, ByRef rこのダイアログから呼び出し As Boolean) As Boolean
        If rリストセル枠色 >= 0 Then
            '外部のダイアログで変更中の色を使用する場合は
            Dim pent As New Pen(ⅩColor構造体_from_色値(rリストセル枠色), 1)
            gggint = ⅩImage_描画長方形枠_線幅指定_ペン指定(pct.Image, rc, pent)
            pent.Dispose()
        Else
            Dim ペン As New Pen(ⅩColor構造体_from_色値(pリストの配色枠の色))
            If ペン IsNot Nothing Then
                gggint = ⅩImage_描画長方形枠_線幅指定_ペン指定(pct.Image, rc, ペン)
                ペン.Dispose()
            End If
            If rこのダイアログから呼び出し Then
                If idx = m使用中リストIDX Then gggint = ooFileListDrag操作.aaCurUseIDX_セル枠設定(pct, rc, mCurBoxWaku)
            End If
        End If
    End Function
    '***********************************************************************
    Private Function zzリストの一セルに描画(ByRef pct As PictureBox, ByRef fff As String, ByRef idx As Integer, ByRef rects() As RECT, ByRef ItemWDHT As Integer, ByRef DoRefresh As Boolean) As Boolean
        '-------------------------------------------------------------------------------------
        Dim ww, xx, yy, hh As Integer
        Dim tmp As Single
        If fff = "" Then
            With rects(idx)
                gggbol = ⅩImageFillRect(pct.Image, pリストの配色背景, .lll, .ttt, .rrr - .lll, .bbb - .ttt, False)
            End With
        Else
            If fff <> "@usecur@" Then
                If "" <> aa画像ファイルオープン_into_ImageBox(fff, mImg現在のファイル, tmp) Then
                    'qqqqq("zzリストの一セルに描画()  fff <> ""@usecur@""  OK")
                End If
            End If
            If mImg現在のファイル IsNot Nothing Then
                With mImg現在のファイル   'pctOpenUse = Error Using
                    If .Width >= .Height Then
                        xx = rects(idx).lll : ww = ItemWDHT : hh = ItemWDHT * (.Height / .Width) : yy = rects(idx).ttt + (ItemWDHT - hh) \ 2 + 1
                    Else
                        ww = ItemWDHT * (.Width / .Height) : xx = rects(idx).lll + (ItemWDHT - ww) \ 2 + 1 : yy = rects(idx).ttt : hh = ItemWDHT
                    End If
                    With rects(idx)
                        gggbol = ⅩImageFillRect(pct.Image, pリストの配色背景, .lll, .ttt, .rrr - .lll, .bbb - .ttt, False)
                    End With
                    gggbol = ⅩImage_Image_Copy(pct.Image, mImg現在のファイル, xx, yy, ww, hh, 0, 0, .Width, .Height)
                End With
            End If
        End If
        Call zzリストの一セル枠を描画(pct, rects(idx), idx, -1, True)
        If DoRefresh Then pct.Refresh()
    End Function
    '***********************************************************************
    Private Function zzリストの選択画像を外す() As Boolean
        'qqqqq mファイル群の名前配列(mCurList)
        Dim a As Integer
        If mCurList = m使用中リストIDX Then
            Beep()
            Return False
        End If
        If mファイル群の名前配列(mCurList) = p画像ファイル規定の内蔵画像 Then
            Beep()
            Return False
        End If
        With pctFileList
            Call ooFileListDrag操作.aaファイルリストシフト移動(mCurList, mListMax - 1, 1, pctFileList, mFileRects, mファイル群の名前配列, m使用中リストIDX, mCurBoxWaku)
            mファイル群の名前配列(mListMax) = ""
            Call zzリストの一セルに描画(pctFileList, "", mListMax, mFileRects, mListItemWDHT, True)
        End With
        mBmp変更済み = mBmp変更済み Or True
        a = mCurList
        Do While mファイル群の名前配列(a) = "" And a > 1 : a = a - 1 : Loop
        gggbol = ooFileListDrag操作.aaマウスイベントを発生させて現在のリストを設定(a, pctFileList, pctDrag, mCurClickWaku, mFileRects, mCurList, mファイル群の名前配列, mBmp変更済み, m使用中リストIDX, mCurBoxWaku, lblFile)
        'qqqqq mファイル群の名前配列(mCurList)
        Return True
    End Function
    '***********************************************************************
    Private Function zzサイズ設定とフォームリサイズ描画長方形枠(ByRef fm As Form, ByRef pct As PictureBox, ByRef lbl As Label, _
                ByRef wFileRects() As RECT, ByRef wListMax As Integer, ByRef rListColX As Integer, ByRef rListLowY As Integer, ByRef wListPichXY As Integer, ByRef rListItemWDHT As Integer, _
                ByRef rリストセル枠色 As Integer, ByRef rリストの配色背景 As Integer, ByRef wSizeOverScreen As Integer, ByRef rこのダイアログから呼び出し As Boolean) As Boolean
        Dim List幅, addx, xx, a, yy, addy, List高 As Integer
        wListMax = rListColX * rListLowY : wListPichXY = rListItemWDHT + cListSpaceXY
        '---------------------------------------------------------------------------
        ReDim wFileRects(wListMax)
        '---------------------------------------------------------------------------
        addx = cLeft - cListSpaceXY : addy = cTop - cListSpaceXY
        For a = 0 To wListMax - 1
            xx = addx + (a Mod rListColX) * wListPichXY + cListSpaceXY : yy = addy + (a \ rListColX) * wListPichXY + cListSpaceXY
            gggint = SetRect(wFileRects(a + 1), xx, yy, xx + rListItemWDHT, yy + rListItemWDHT)
        Next
        '---------------------------------------------------------------------------
        List幅 = cLeft + wListPichXY * rListColX - cListSpaceXY + cRight + 2
        List高 = cTop + wListPichXY * rListLowY - cListSpaceXY + cBottom + 2
        With pct : .SetBounds(.Left, .Top, List幅, List高) : .Visible = True : End With
        gggbol = ⅩPictreBox_Image_再作成(pct, List幅, List高)
        '---------------------------------------------------------------------------
        gggbol = ⅩImageFillRect(pct.Image, rリストの配色背景, 0, 0, pct.Image.Width, pct.Image.Height, False)
        '2022/05/08  重要　空の領域でも、一度は描画していないと、後のシフト異動で、空の領域が描画されない。
        Dim WD As Integer = ⅩRect幅(wFileRects(1)), HT As Integer = ⅩRect高(wFileRects(1))
        For a = 1 To wListMax
            gggbol = ⅩImageFillRect(pct.Image, rリストの配色背景, wFileRects(a).lll, wFileRects(a).ttt, WD, HT, False)
            Call zzリストの一セル枠を描画(pct, wFileRects(a), a, rリストセル枠色, rこのダイアログから呼び出し)
        Next
        '---------------------------------------------------------------------------
        '2022/05/11 　in  mn00画像リストのデザイン変更_Click() ダイアログからサイズ変更が戻ってきた後では、サイズ変更は後回しにする　
        If Not mOnAfterSizeDlg Then
            xx = pct.Left : wSizeOverScreen = ⅩFormSizeSetByControlSize(fm, pct, xx, xx, True, False)
        End If
        mOnAfterSizeDlg = False
        '---------------------------------------------------------------------------
        lbl.Top = mMenuHight + cToplblFile
        lbl.Left = cLeft : lbl.Width = wFileRects(rListColX).rrr - (lbl.Left)
        '---------------------------------------------------------------------------
        Return True
    End Function
    '***********************************************************************
    Private Function zzサイズセット_mListItemWDHT_mListColX_mListLowY(Optional ByRef rListItemWDHT As Integer = 100, Optional ByRef rListColX As Integer = 8, Optional ByRef rListLowY As Integer = 6) As Boolean
        mListItemWDHT = Ⅹ数値範囲Int(66, 200, rListItemWDHT)
        mListColX = Ⅹ数値範囲Int(6, 16, rListColX)
        mListLowY = Ⅹ数値範囲Int(4, 12, rListLowY)
        Return True
    End Function
    '***********************************************************************
    Private Function zzサイズ設定とフォームリサイズ(ByRef rサイズ設定をする As Boolean, ByRef rBmpMaxWDHTを設定をする As Boolean, ByRef rすでにImageデーターがある As Boolean, _
                Optional ByRef rBmpMaxWD As Integer = 0, Optional ByRef rBmpMaxHT As Integer = 0, Optional ByRef rListItemWDHT As Integer = 100, Optional ByRef rListColX As Integer = 8, Optional ByRef rListLowY As Integer = 6) As Boolean
        Dim wSizeOverScreen As Integer
        Dim bol As Boolean
        zzサイズ設定とフォームリサイズ = False
        '---------------------------------------------------------------------------
        If rサイズ設定をする Then
            gggbol = zzサイズセット_mListItemWDHT_mListColX_mListLowY(rListItemWDHT, rListColX, rListLowY)
        End If
        '---------------------------------------------------------------------------
        bol = zzサイズ設定とフォームリサイズ描画長方形枠(Me, pctFileList, lblFile, mFileRects, mListMax, mListColX, mListLowY, mListPichXY, mListItemWDHT, pリストの配色枠の色, pリストの配色背景, wSizeOverScreen, True)
        '---------------------------------------------------------------------------
        If rBmpMaxWDHTを設定をする Then
            If rBmpMaxWD = 0 Or rBmpMaxHT = 0 Then
                mBmpMaxWD = cBmpMaxWD : mBmpMaxHT = cBmpMaxHT '規定値を使用
            Else
                mBmpMaxWD = Ⅹ数値範囲Int(cBmpMaxWD \ 10, cBmpMaxWD, rBmpMaxWD) 'ユーザー指定値を使用
                mBmpMaxHT = Ⅹ数値範囲Int(cBmpMaxHT \ 10, cBmpMaxHT, rBmpMaxHT) 'ユーザー指定値を使用
            End If
        End If
        '---------------------------------------------------------------------------
        gggbol = zzRedim_mファイル群の名前配列(mListMax)
        '---------------------------------------------------------------------------
        gggint = ooFileListDrag操作.aaStartSet(False, mListMax, mListColX, mListItemWDHT, True, True, True, pctFileList.Left, pctFileList.Top)
        '---------------------------------------------------------------------------
        zzサイズ設定とフォームリサイズ = True
        'qqqqq "四frmDlgPctFilesList---zzサイズ設定とフォームリサイズ"
    End Function
    '***********************************************************************
    Private Function zzRedim_mファイル群の名前配列(ByVal max As Integer) As Boolean
        ReDim Preserve mファイル群の名前配列(max) '2019/06/19  すでに INI のデーターが読み込まれている場合がありうる。
        For a As Integer = 0 To max
            If mファイル群の名前配列(a) Is Nothing Then mファイル群の名前配列(a) = ""
        Next
        Return True
    End Function
    '***********************************************************************
    Private Function zz現在の登録枚数() As Integer
        Dim a As Integer
        For a = 1 To mListMax
            If mファイル群の名前配列(a) = "" Then Exit For
        Next
        Return a - 1
    End Function
    '***********************************************************************
    Private Function zz存在しないファイルが_mファイル群の名前配列内にあれば_TRUE_を返す() As Boolean
        Dim a As Integer : Dim f As String
        For a = 1 To mListMax
            f = mファイル群の名前配列(a)
            If f = "" Then Exit For
            If zzアプリ規定の内蔵画像ではなく_読み込めないあるいは存在しない画像ファイル(f, False, "") Then Return True
        Next
        Return False
    End Function
    '***********************************************************************
    Private Function zz存在しないファイルを_mファイル群の名前配列から削除(ByVal MsgBoxShow As Boolean) As Boolean
        Dim a, b As Integer
        Dim f As String
        Dim RET As Boolean = False
        For a = 1 To mListMax
            f = mファイル群の名前配列(a)
            If f = "" Then Exit For
            If zzアプリ規定の内蔵画像ではなく_読み込めないあるいは存在しない画像ファイル(f, MsgBoxShow, "") Then
                For b = a To mListMax - 1
                    mファイル群の名前配列(b) = mファイル群の名前配列(b + 1)
                Next
                mファイル群の名前配列(mListMax) = ""
                If mCurList > a Then mCurList = Math.Max(1, mCurList - 1)
                a = a - 1
                RET = True
            End If
        Next
        Return RET
    End Function
    '***********************************************************************
    Private Function zzアプリ規定の内蔵画像ではなく_読み込めないあるいは存在しない画像ファイル(ByRef f As String, ByRef MsgBoxShow As Boolean, ByRef MsgLastAddStr As String) As Boolean
        Dim b As Boolean
        b = (f <> p画像ファイル規定の内蔵画像) And (Not (ⅩファイルはPictureBoxで読み込める画像(f) And Ⅹファイルは存在(f)))
        If b And MsgBoxShow Then
            MsgBox(ⅩDBQA(f) & gggCR2 & "このファイルタイプを使用できません。" & gggCR2 & "このファイルは、画像リストに登録できません。" & MsgLastAddStr, 48, "ファイルを使用できません")
        End If
        Return b
    End Function
    '***********************************************************************
    Private Function zz画像の数が_リスト数より多い(ByRef oldRects() As RECT, ByRef newRects() As RECT) As Boolean
        Dim m1, a, m2 As Integer
        zz画像の数が_リスト数より多い = False
        m1 = Math.Min(UBound(oldRects), UBound(mファイル群の名前配列))
        m2 = UBound(newRects)
        If m2 >= m1 Then Exit Function
        For a = 1 To m1
            If mファイル群の名前配列(a) = "" Then Exit For
        Next
        a = a - 1
        If m2 >= a Then Exit Function
        zz画像の数が_リスト数より多い = True
    End Function
    '***********************************************************************
    Private Function zz選択ファイル名からインデックス(ByVal r選択ファイル名 As String) As Integer
        Dim a As Integer
        If r選択ファイル名 <> "" Then
            For a = 1 To mListMax
                If mファイル群の名前配列(a) = r選択ファイル名 Then Return a
            Next
        End If
        Return 0
    End Function
    '***********************************************************************
    Private Function zzマウスポイントの_mFileRect_Index(ByRef X As Integer, ByRef Y As Integer) As Integer
        Dim a As Integer
        For a = 1 To mListMax
            If mファイル群の名前配列(a) = "" Then Exit For
            If ⅩRect内にXY座標がある(X, Y, mFileRects(a)) Then Return a
        Next
        Return 0
    End Function
    '***********************************************************************
#End Region

#Region "イベント from mDlgSetSize"

    Private Sub mDlgSetSize_最大制限フォームサイズ_を知らせてください(ByRef rUserName As String, ByRef wフォーム最大制限WD As Integer, ByRef wフォーム最大制限HT As Integer, ByRef wフォームとPct差分WD As Integer, ByRef wフォームとPct差分HT As Integer) Handles mDlgSetSize.最大制限フォームサイズ_を知らせてください
        If rUserName <> Me.Text Then Return
        wフォーム最大制限WD = Screen.PrimaryScreen.Bounds.Width * 0.95
        wフォーム最大制限HT = Screen.PrimaryScreen.Bounds.Height * 0.95
        wフォームとPct差分WD = Me.Width - pctFileList.Width
        wフォームとPct差分HT = Me.Height - pctFileList.Height
    End Sub
    Private Sub mDlgSetSize_画像リストのデーターをください(ByRef rUserName As String, ByRef rwFormWD As Integer, ByRef rwFormHT As Integer, ByRef rw使用中リストIDX As Integer, ByRef rw現在の登録枚数 As Integer, ByRef rwpctFileList As PictureBox, ByRef rwlblFile As Label, ByRef rwLRects() As Rectangle, ByRef rwListMax As Integer, ByRef rwListColX As Integer, ByRef rwListLowY As Integer, ByRef rwListPichXY As Integer, ByRef rwListItemWDHT As Integer, ByRef rwリストセル枠色 As Integer, ByRef rwリストの配色背景 As Integer) Handles mDlgSetSize.画像リストのデーターをください
        If rUserName <> Me.Text Then Return
        Dim mnuHT As Integer = pctFileList.Top
        rwFormWD = Me.Width
        rwFormHT = Me.Height
        rw使用中リストIDX = m使用中リストIDX
        rw現在の登録枚数 = zz現在の登録枚数()
        gggbol = ⅩRect_RectAngle_交換_配列(0, mFileRects, rwLRects)
        rwListMax = mListMax : rwListColX = mListColX : rwListLowY = mListLowY : rwListPichXY = mListPichXY : rwListItemWDHT = mListItemWDHT : rwリストセル枠色 = pリストの配色枠の色 : rwリストの配色背景 = pリストの配色背景
        With pctFileList
            rwpctFileList.SetBounds(.Left, .Top, .Width, .Height)
        End With
        With lblFile
            rwlblFile.SetBounds(.Left, .Top, .Width, .Height)
        End With
    End Sub
    Private Sub mDlgSetSize_画像リストを呼び出し元に描画してください(ByRef rUserName As String, ByRef fm As Form, ByRef rw使用中リストIDX As Integer, ByRef rwpctFileList As PictureBox, ByRef rwlblFile As Label, _
                    ByRef rwLRects() As Rectangle, ByRef rwListMax As Integer, ByRef rwListColX As Integer, ByRef rwListLowY As Integer, ByRef rwListPichXY As Integer, ByRef rwListItemWDHT As Integer, _
                    ByRef rwリストセル枠色 As Integer, ByRef rwリストの配色背景 As Integer) Handles mDlgSetSize.画像リストを呼び出し元に描画してください
        If rUserName <> Me.Text Then Return
        Dim tmpRect(0) As RECT : Dim wSizeOverScreen As Integer
        gggbol = ⅩRect_RectAngle_交換_配列(1, tmpRect, rwLRects)
        gggbol = zzサイズ設定とフォームリサイズ描画長方形枠(fm, rwpctFileList, rwlblFile, tmpRect, rwListMax, rwListColX, rwListLowY, rwListPichXY, rwListItemWDHT, rwリストセル枠色, rwリストの配色背景, wSizeOverScreen, False)
    End Sub
    Private Sub mDlgSetSize_新しいサイズが決定されました(ByRef rUserName As String, ByRef rwFormWD As Integer, ByRef rwFormHT As Integer, ByRef rw使用中リストIDX As Integer, ByRef rwpctFileList As PictureBox, ByRef rwlblFile As Label, ByRef rwLRects() As Rectangle, ByRef rwListMax As Integer, ByRef rwListColX As Integer, ByRef rwListLowY As Integer, ByRef rwListPichXY As Integer, ByRef rwListItemWDHT As Integer, ByRef rwリストセル枠色 As Integer, ByRef rwリストの配色背景 As Integer) Handles mDlgSetSize.新しいサイズが決定されました
        If rUserName <> Me.Text Then Return
        gggbol = ⅩRect_RectAngle_交換_配列(1, mFileRects, rwLRects)
        mListItemWDHT = rwListItemWDHT
        mListMax = rwListMax
        mListColX = rwListColX
        mListLowY = rwListLowY
        pリストの配色枠の色 = rwリストセル枠色
        pリストの配色背景 = rwリストの配色背景
        gggbol = zzRedim_mファイル群の名前配列(mListMax) 'ReDim Preserve mファイル群の名前配列(mListMax)
    End Sub

#End Region

#Region "イベント from gAppEventMaker"

    Private Sub イベントgAppEventMaker_カードショー開始と停止(ByVal r開始true停止false As Boolean) Handles イベントgAppEventMaker.カードショー開始と停止
        If Me.Visible Then
            If r開始true停止false Then
                Call mn900閉じる_Click(Nothing, Nothing)
            End If
        End If
    End Sub

    Private Sub イベントgAppEventMaker_画像切り替えタイマーのオンオフ(ByRef rEventOwner As Integer, ByRef rTimerOnOff As Boolean, ByRef wRetVal As Boolean) Handles イベントgAppEventMaker.画像切り替えタイマーのオンオフ
        Select Case mDlgUserID
            '-------------------------------------------
            Case gmDlgFileゲーム用
                If rEventOwner = gmDlgFileゲーム用 Then
                    tim切り替えタイマー.Enabled = rTimerOnOff And ppゲーム実行中
                    wRetVal = True
                    'qqqqq(CStr(tim切り替えタイマー.Enabled))
                End If
                '-------------------------------------------
            Case gmDlgFileスイスイ用
                If rEventOwner = gmDlgFileスイスイ用 Then
                    tim切り替えタイマー.Enabled = rTimerOnOff And ppスイスイフラフラ_いずれかあるいは両方_を実行中
                    wRetVal = True
                    'qqqqq(CStr(tim切り替えタイマー.Enabled))
                End If
                '-------------------------------------------
        End Select
    End Sub

    Private Sub イベントgAppEventMaker_スイスイユラユラ画像表示ONOFF(ByVal r画像表示OnOff As Boolean) Handles イベントgAppEventMaker.スイスイユラユラ画像表示ONOFF
        If gmアプリ終了する Then Return
        Select Case mDlgUserID
            Case gmDlgFileスイスイ用
                mn8スイスイとユラユラを実行.Enabled = r画像表示OnOff
                mn8ユラユラ実行.Enabled = r画像表示OnOff
        End Select
    End Sub

    Private Sub イベントgAppEventMaker_スイスイとユラユラ開始と停止() Handles イベントgAppEventMaker.スイスイとユラユラ開始と停止
        Select Case mDlgUserID
            '-------------------------------------------
            Case gmDlgFileゲーム用
                If ppスイスイフラフラ_いずれかあるいは両方_を実行中 Then Call mn900閉じる_Click(Nothing, Nothing)
                '-------------------------------------------
            Case gmDlgFileスイスイ用
                Dim e0 As Boolean = ppスイスイフラフラ_いずれも停止している
                mn00複数ファイルを登録.Enabled = e0
                mn00選択画像を外す.Enabled = e0
                mn00画像リストファイルの再設定.Enabled = e0
                mn00画像リストのデザイン変更.Enabled = e0
                mn500フォルダを開く.Enabled = e0
                mn00pop複数ファイルを登録.Enabled = e0
                mn00pop選択画像を外す.Enabled = e0
                mn500popフォルダを開く.Enabled = e0
                gggbol = イベントgAppEventMaker.スイスイとユラユラ開始と停止_共通処理("gmDlgFileスイスイ用", mn8スイスイとユラユラを実行, mn8スイスイとユラユラすべて停止, _
                                                   mn8スイスイ実行, mn8スイスイ停止, mn8ユラユラ実行, mn8ユラユラ停止, _
                                                   mn8スイスイとユラユラを表示, Nothing)
        End Select
    End Sub

    Private Sub イベントgAppEventMaker_タイマーのオンオフonスイスイonff(ByRef rEventOwner As Integer, ByRef rTimerオン As Boolean) Handles イベントgAppEventMaker.タイマーのオンオフonスイスイonff
        Select Case mDlgUserID
            '-------------------------------------------
            Case gmDlgFileゲーム用
                If rEventOwner = gmDlgFileゲーム用 Then
                    tim切り替えタイマー.Enabled = rTimerオン And ppゲーム実行中
                End If
                '-------------------------------------------
            Case gmDlgFileスイスイ用
                If rEventOwner = gmDlgFileスイスイ用 Then
                    tim切り替えタイマー.Enabled = rTimerオン And ppスイスイフラフラ_いずれかあるいは両方_を実行中
                End If
        End Select
    End Sub

    Private Sub イベントgAppEventMaker_ゲーム開始と停止(ByVal r開始True停止False As Boolean, ByRef wOptionRetStr As String) Handles イベントgAppEventMaker.ゲーム開始と停止
        Select Case mDlgUserID
            '-------------------------------------------
            Case gmDlgFileゲーム用
                'no op
                '-------------------------------------------
            Case gmDlgFileスイスイ用
                If r開始True停止False Then
                    Call mn900閉じる_Click(Nothing, Nothing)
                Else

                End If
        End Select
    End Sub

    Private Sub イベントgAppEventMaker_フォームの表示と消去(ByVal rフォーム名ID As Integer, ByVal r表示True消去False As Boolean) Handles イベントgAppEventMaker.フォームの表示と消去
        '-------------------------------------------
        If Me.Visible = False Then Return
        '-------------------------------------------
        If gmアプリ終了する Then
            qqqqq("gmアプリ終了する Event_フォームの表示と消去()" + Me.Name)
            Return
        End If
        '-------------------------------------------
        Dim wRet_rMe_gmDlgIDウインドウを消去しなさい As Boolean = GMCOM_Dlgs他のウインドウの表示_非表示イベントで_rMe_ウインドウを消去しなさい(mDlgUserID, rフォーム名ID, r表示True消去False)
        If wRet_rMe_gmDlgIDウインドウを消去しなさい Then
            Call mn900閉じる_Click(Nothing, Nothing)
        ElseIf (mDlgUserID = gmDlgFileスイスイ用) And (rフォーム名ID = gmDlgスイスイユラユラ) Then
            mn8スイスイとユラユラを表示.Enabled = Not r表示True消去False
        ElseIf (mDlgUserID = gmDlgFileスイスイ用) And (rフォーム名ID = gmDlgFileスイスイ用) Then
            mn8スイスイとユラユラを表示.Enabled = Not r表示True消去False
        End If
    End Sub

    Private Sub イベントgAppEventMaker_ゲーム背景画像の表示ONOFF(ByVal r画像表示OnOff As Boolean) Handles イベントgAppEventMaker.ゲーム背景画像の表示ONOFF
        'Urouro 専用イベント
        Select Case mDlgUserID
            Case gmDlgFileゲーム用
                If Not r画像表示OnOff Then
                    Call mn900閉じる_Click(Nothing, Nothing)
                Else

                End If
        End Select

    End Sub

#End Region

End Class

